//%2006////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2000, 2001, 2002 BMC Software; Hewlett-Packard Development
// Company, L.P.; IBM Corp.; The Open Group; Tivoli Systems.
// Copyright (c) 2003 BMC Software; Hewlett-Packard Development Company, L.P.;
// IBM Corp.; EMC Corporation, The Open Group.
// Copyright (c) 2004 BMC Software; Hewlett-Packard Development Company, L.P.;
// IBM Corp.; EMC Corporation; VERITAS Software Corporation; The Open Group.
// Copyright (c) 2005 Hewlett-Packard Development Company, L.P.; IBM Corp.;
// EMC Corporation; VERITAS Software Corporation; The Open Group.
// Copyright (c) 2006 Hewlett-Packard Development Company, L.P.; IBM Corp.;
// EMC Corporation; Symantec Corporation; The Open Group.
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// THE ABOVE COPYRIGHT NOTICE AND THIS PERMISSION NOTICE SHALL BE INCLUDED IN
// ALL COPIES OR SUBSTANTIAL PORTIONS OF THE SOFTWARE. THE SOFTWARE IS PROVIDED
// "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
// PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
// ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//
//==============================================================================
//
// Author:      Adrian Schuur, schuur@de.ibm.com
//              Mark Hamzy, hamzy@us.ibm.com
//
// Modified By:
//
//%/////////////////////////////////////////////////////////////////////////////
package org.pegasus.jmpi;

import java.util.Vector;

public interface InstanceProvider2
                 extends CIMProvider
{
    public CIMInstance getInstance                (OperationContext oc,
                                                   CIMObjectPath    cop,
                                                   CIMClass         cimClass,
                                                   boolean          includeQualifiers,
                                                   boolean          includeClassOrigin,
                                                   String           propertyList[])
        throws CIMException;


    public CIMObjectPath createInstance           (OperationContext oc,
                                                   CIMObjectPath    cop,
                                                   CIMInstance      cimInstance)
        throws CIMException;


    public abstract void setInstance              (OperationContext oc,
                                                   CIMObjectPath    cop,
                                                   CIMInstance      cimInstance)
        throws CIMException;


    public abstract void deleteInstance           (OperationContext oc,
                                                   CIMObjectPath    cop)
         throws CIMException;


    public abstract Vector enumerateInstances     (OperationContext oc,
                                                   CIMObjectPath    cop,
                                                   CIMClass         cimClass,
                                                   boolean          includeQualifiers,
                                                   boolean          includeClassOrigin,
                                                   String           propertyList[])
        throws CIMException;


    public abstract Vector enumerateInstanceNames (OperationContext oc,
                                                   CIMObjectPath    cop,
                                                   CIMClass         cimClass)
        throws CIMException;


    public abstract Vector execQuery              (OperationContext oc,
                                                   CIMObjectPath    cop,
                                                   CIMClass         cimClass,
                                                   String           queryStatement,
                                                   String           queryLanguage)
        throws CIMException;
}
